<?php
/**
 * @package plg_sectionList for Joomla! 1.5
 * @version $Id: sectionlist.php 2010-10-26 23:43:12 $
 * @author Andreas Thul
 * @copyright (C) 2009, 2010 Andreas Thul
 * @license PERL Artistic License 2.0 http://www.perlfoundation.org/artistic_license_2_0
**/

defined('_JEXEC') or die('Restricted access');

jimport('joomla.plugin.plugin');

class plgContentSectionList extends JPlugin {

	function plgContentSectionList(& $subject, $params ) {

		parent::__construct( $subject, $params );
	}

	function onAfterDisplayContent( &$article, &$params, $limitstart ) {

		global $mainframe;

		// get the plugin parameters
		$plugin =& JPluginHelper::getPlugin('content', 'sectionlist');
		$pluginParams = new JParameter( $plugin->params);
		$cattag = $pluginParams->get('cattag', 'h2');
		$listtype = $pluginParams->get('listtype', 'ul');
		$style = $pluginParams->get('style', 'sectionlist');

		if (preg_match("/{\s*sectionlist\s*:\s*(\d+)\s*}/", $article->text, $matches)) {

			$db =& JFactory::getDBO();
			$id = $matches[1];

			// query inspired by mod_latestnews as the article path has to be delivered, too
			$nullDate	= $db->getNullDate();

			$date =& JFactory::getDate();
			$now = $date->toMySQL();

			$query = 'SELECT a.*, ';
			$query .= ' CASE WHEN CHAR_LENGTH(a.alias) THEN CONCAT_WS(":", a.id, a.alias) ELSE a.id END as slug,';
			$query .= ' CASE WHEN CHAR_LENGTH(cc.alias) THEN CONCAT_WS(":", cc.id, cc.alias) ELSE cc.id END as catslug,';
			$query .= ' cc.title as cattitle, cc.ordering as catorder';
			$query .= ' FROM #__content AS a';
			$query .= ' INNER JOIN #__categories AS cc ON cc.id = a.catid';
			$query .= ' INNER JOIN #__sections AS s ON s.id = a.sectionid';
			$query .= ' WHERE a.id <> ' . $article->id;
			$query .= " AND a.sectionid = $id";
			$query .= ' AND a.state = 1 AND ( a.publish_up = '.$db->Quote($nullDate).' OR a.publish_up <= '.$db->Quote($now).' ) AND ( a.publish_down = '.$db->Quote($nullDate).' OR a.publish_down >= '.$db->Quote($now).' )';
			$query .= " ORDER BY catorder ASC, a.ordering ASC";

			$db->setQuery($query);

			$buffer = "<div class=\"$style\">\n";
			$count = 0;
			$acttitle = '';

			if ($result = $db->loadObjectList()) {

				foreach ($result as $item) {

					if ($item->cattitle != $acttitle) {

						if ($count) { $buffer .= "</$listtype>"; }
						$buffer .= "<$cattag>" . $item->cattitle . "</$cattag>\n<$listtype>\n";
						$acttitle = $item->cattitle;
					}

					$route = ContentHelperRoute::getArticleRoute($item->slug, $item->catslug, $item->sectionid);
					$url = JRoute::_($route);

					$buffer .= "<li><a href=\"$url\">" . $item->title . "</a></li>\n";
					$count ++;

				}

			}

			if ($count) { $buffer .= "</div>\n"; }

			$article->text = preg_replace("/{\s*sectionlist\s*:\s*(\d+)\s*}/", $buffer, $article->text, 1);

		}

	}

}

?>
